/*! edge-builder v1.0.0-alpha.12 by Sebastian Software <s.werner@sebastian-software.de> */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('core-js/modules/es6.array.iterator');
require('core-js/modules/es6.object.keys');
require('core-js/modules/web.dom.iterable');
require('core-js/modules/es6.array.for-each');
require('core-js/modules/es7.array.includes');
require('core-js/modules/es6.string.includes');
require('core-js/modules/es6.string.ends-with');
require('core-js/modules/es6.string.starts-with');
require('core-js/modules/es6.regexp.replace');
require('core-js/modules/es6.array.index-of');
require('core-js/modules/es6.array.last-index-of');
var ora = _interopDefault(require('ora'));
var appRootDir = require('app-root-dir');
var path = require('path');
require('core-js/modules/es6.string.iterator');
require('core-js/modules/es6.set');
var fs = require('fs');
var fs__default = _interopDefault(fs);
var fsExtra = require('fs-extra');
var builtinModules = _interopDefault(require('builtin-modules'));
var resolvePkg = _interopDefault(require('resolve-pkg'));
require('core-js/modules/es6.array.filter');
require('core-js/modules/es6.regexp.constructor');
require('core-js/modules/es6.regexp.split');
require('core-js/modules/es7.symbol.async-iterator');
require('core-js/modules/es6.symbol');
require('core-js/modules/es6.array.is-array');
require('core-js/modules/es6.array.from');
require('core-js/modules/es6.string.bold');
var webpack = _interopDefault(require('webpack'));
var chalk = _interopDefault(require('chalk'));
require('webpack/package.json');
var ExtractCssChunks = _interopDefault(require('extract-css-chunks-webpack-plugin'));
var StatsPlugin = _interopDefault(require('stats-webpack-plugin'));
var CaseSensitivePathsPlugin = _interopDefault(require('case-sensitive-paths-webpack-plugin'));
var SriPlugin = _interopDefault(require('webpack-subresource-integrity'));
var BundleAnalyzerPlugin = _interopDefault(require('webpack-bundle-analyzer'));
var loaderUtils = require('loader-utils');
require('core-js/modules/es6.promise');
var bluebird = require('bluebird');
var formatWebpackMessages = _interopDefault(require('react-dev-utils/formatWebpackMessages'));
var edgeCommon = require('edge-common');
var webpackDevMiddleware = _interopDefault(require('webpack-dev-middleware'));
var webpackHotMiddleware = _interopDefault(require('webpack-hot-middleware'));
var webpackHotServerMiddleware = _interopDefault(require('webpack-hot-server-middleware'));
var clipboardy = _interopDefault(require('clipboardy'));

var ROOT = appRootDir.get();

var VerboseProgress =
/*#__PURE__*/
function () {
  function VerboseProgress(_ref) {
    var prefix = _ref.prefix;
    this.prefix = prefix;
  }

  var _proto = VerboseProgress.prototype;

  _proto.apply = function apply(compiler) {
    var spinner = null;
    var lastModule = null;
    var prefix = this.prefix ? this.prefix + " " : "";

    function display(message) {
      if (message !== "") {
        spinner.text = prefix + message;
        spinner.render();
      } else {
        spinner.succeed(prefix + "Done!");
      }
    }

    function moduleDone() {
      var humanIndex;
      var humanModuleId = lastModule;
      humanIndex = humanModuleId.lastIndexOf(" ");
      humanModuleId = humanIndex === -1 ? humanModuleId : humanModuleId.slice(humanIndex + 1, humanModuleId.length);
      humanIndex = humanModuleId.lastIndexOf("!");
      humanModuleId = humanIndex === -1 ? humanModuleId : humanModuleId.slice(humanIndex + 1, humanModuleId.length);
      humanIndex = humanModuleId.indexOf("?");
      humanModuleId = humanIndex === -1 ? humanModuleId : humanModuleId.slice(0, humanIndex);
      humanModuleId = path.relative(ROOT, humanModuleId).replace(/^node_modules\//, "~/");

      if (humanModuleId.startsWith('"') && humanModuleId.endsWith('"')) {
        humanModuleId = humanModuleId.slice(1, -1);
      }

      if (humanModuleId.includes("|")) {
        return;
      }

      if (humanModuleId.startsWith("..")) {
        return;
      }

      if (/^[a-zA-Z0-9\-_/~\.]{0,50}$/.test(humanModuleId)) {
        display("Building Modules " + humanModuleId + "...");
      }
    }

    compiler.plugin("compilation", function (compilation) {
      if (compilation.compiler.isChild()) {
        return;
      }

      spinner = ora({
        interval: 16
      });
      spinner.start();
      display(0, "compiling");
      compilation.plugin("build-module", function (module) {
        lastModule = module.identifier();
      });
      compilation.plugin("failed-module", moduleDone);
      compilation.plugin("succeed-module", moduleDone);
      var syncHooks = {
        seal: "Sealing",
        optimize: "Optimizing",
        "optimize-modules-basic": "Optimizing modules",
        "optimize-chunks-basic": "Optimizing chunks",
        "optimize-chunk-modules": "Optimizing chunk modules",
        "optimize-module-order": "Optimizing module order",
        "optimize-module-ids": "Optimizing module ids",
        "optimize-chunk-order": "Optimizing chunk order",
        "optimize-chunk-ids": "Optimizing chunk ids",
        "before-hash": "Hashing",
        "before-module-assets": "Processing module assets",
        "before-chunk-assets": "Processing chunk assets",
        record: "Recording"
      };
      Object.keys(syncHooks).forEach(function (name) {
        var pass = 0;
        var message = syncHooks[name];
        compilation.plugin(name, function () {
          if (pass++ > 0) display(message + (" [pass " + pass + "]"));else display(message);
        });
      });
      compilation.plugin("optimize-tree", function (chunks, modules, callback) {
        display("Optimizing tree");
        callback();
      });
      compilation.plugin("additional-assets", function (callback) {
        display("Processing assets");
        callback();
      });
      compilation.plugin("optimize-chunk-assets", function (chunks, callback) {
        display("Optimizing chunk assets");
        callback();
      });
      compilation.plugin("optimize-assets", function (assets, callback) {
        display("Optimizing assets");
        callback();
      });
    });
    compiler.plugin("emit", function (compilation, callback) {
      display("Emitting");
      callback();
    });
    compiler.plugin("done", function () {
      display("");
    });
  };

  return VerboseProgress;
}();

var BuiltIns = new Set(builtinModules);
var BundleWithWebpack = new Set(["react-universal-component", "webpack-flush-chunks", "babel-plugin-universal-import"]);
var Problematic = new Set(["intl", "mime-db", "encoding", "ajv", "colors", "jsdom", "node-fetch"]);
function isLoaderSpecificFile(request) {
  if (request.charAt(0) === "!") {
    return true;
  }

  return !!/\.(eot|woff|woff2|ttf|otf|svg|png|jpg|jpeg|gif|webp|webm|ico|mp4|mp3|ogg|html|pdf|css|scss|sass|sss|less|zip)$/.exec(request);
}
var bundleCache = {};
function shouldPackageBeBundled(resolved) {
  var result = null;
  var hasBindings = fs.existsSync(path.resolve(resolved, "bindings.gyp"));

  if (hasBindings) {
    result = false;
  } else {
    var json;

    try {
      json = fsExtra.readJsonSync(path.resolve(resolved, "package.json"));
    } catch (error) {}

    if (json) {
      if (json.module || json.style || json.browser || json["jsnext:main"]) {
        result = true;
      }

      if (json.binary != null) {
        result = false;
      }
    }
  }

  return result;
}
function shouldBeBundled(basename) {
  if (basename in bundleCache) {
    return bundleCache[basename];
  }

  var resolved;

  try {
    resolved = resolvePkg(basename);
  } catch (error) {
    return null;
  }

  var result = resolved ? shouldPackageBeBundled(resolved) : null;
  bundleCache[basename] = result;
  return result;
}
function isRequestExternal(request, lightweight) {
  if (lightweight === void 0) {
    lightweight = false;
  }

  if (request.charAt(0) === ".") {
    return false;
  }

  if (isLoaderSpecificFile(request)) {
    return false;
  }

  var match = /^((@[\w-]+\/)?[\w-]+)\/?/.exec(request);
  var basename = match ? match[1] : null;

  if (basename == null) {
    console.warn("Couldn't figure out package name from require:", request);
    return true;
  }

  if (BuiltIns.has(basename)) {
    return true;
  }

  if (BundleWithWebpack.has(basename)) {
    return false;
  }

  if (Problematic.has(basename)) {
    return true;
  }

  var bundle = shouldBeBundled(basename);

  if (bundle != null) {
    return !bundle;
  }

  return lightweight;
}
var externalsCache = {};
function getServerExternals(lightweight, entries) {
  var entriesSet = new Set(entries);
  return function (context, request, callback) {
    if (entriesSet.has(request)) {
      return callback();
    }

    var isExternal = externalsCache[request];

    if (isExternal == null) {
      isExternal = isRequestExternal(request, lightweight);
      externalsCache[request] = isExternal;
    }

    return isExternal ? callback(null, "commonjs " + request) : callback();
  };
}

var ROOT$1 = appRootDir.get();
var assetFiles = /\.(eot|woff|woff2|ttf|otf|svg|png|jpg|jpeg|jp2|jpx|jxr|gif|webp|mp4|mp3|ogg|pdf|html|ico)$/;
var babelFiles = /\.(js|mjs|jsx)$/;
var postcssFiles = /\.(css|sss|pcss)$/;

var identityFnt = function identityFnt(item) {
  return item;
};

function builder(target, env, config) {
  if (env === void 0) {
    env = "development";
  }

  if (config === void 0) {
    config = {};
  }

  var SERVER_OUTPUT = config.output.server;
  var CLIENT_OUTPUT = config.output.client;
  var BABEL_ENV = config.build.babelEnvPrefix + "-" + env + "-" + target;

  var PROJECT_CONFIG = require(path.resolve(ROOT$1, "package.json"));

  var CACHE_HASH = loaderUtils.getHashDigest(JSON.stringify(PROJECT_CONFIG), "sha256", "base62", 4);
  var PREFIX = chalk.bold(target.toUpperCase());
  var DEFAULT_LOCALE = config.locale.default;
  var SUPPORTED_LOCALES = config.locale.supported;
  var isServer = target === "server";
  var isClient = target === "client";
  var isDevelopment = env === "development";
  var isProduction = env === "production";

  var SUPPORTED_LANGUAGES = function () {
    var languages = new Set();

    for (var _iterator = SUPPORTED_LOCALES, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var entry = _ref;
      languages.add(entry.split("-")[0]);
    }

    return Array.from(languages.keys());
  }();

  var LEAN_INTL_REGEXP = new RegExp("\\b" + SUPPORTED_LOCALES.join("\\b|\\b") + "\\b");
  var REACT_INTL_REGEXP = new RegExp("\\b" + SUPPORTED_LANGUAGES.join("\\b|\\b") + "\\b");
  var name = isServer ? "server" : "client";
  var webpackTarget = isServer ? "node" : "web";
  var devtool = config.build.enableSourceMaps ? "source-map" : false;
  console.log(chalk.underline(PREFIX + " Configuration:"));
  console.log("\u2192 Environment: " + env);
  console.log("\u2192 Webpack Target: " + webpackTarget);

  if (config.verbose) {
    console.log("\u2192 Babel Environment: " + BABEL_ENV);
    console.log("\u2192 Enable Source Maps: " + devtool);
    console.log("\u2192 Use Cache Loader: " + config.build.useCacheLoader + " [Hash: " + CACHE_HASH + "]");
    console.log("\u2192 Default Locale: " + DEFAULT_LOCALE);
    console.log("\u2192 Supported Locales: " + SUPPORTED_LOCALES);
    console.log("\u2192 Supported Languages: " + SUPPORTED_LANGUAGES);
  }

  var CACHE_LOADER_DIRECTORY = path.resolve(ROOT$1, ".cache/loader-" + CACHE_HASH + "-" + target + "-" + env);
  var cacheLoader = config.build.useCacheLoader ? {
    loader: "cache-loader",
    options: {
      cacheDirectory: CACHE_LOADER_DIRECTORY
    }
  } : null;
  var cssLoaderOptions = {
    modules: true,
    localIdentName: "[local]-[hash:base62:8]",
    import: false,
    minimize: false,
    sourceMap: config.build.enableSourceMaps
  };
  var postCSSLoaderRule = {
    loader: "postcss-loader",
    query: {
      sourceMap: config.build.enableSourceMaps
    }
  };
  var VENDOR_ENTRY = isServer ? config.entry.serverVendor : config.entry.clientVendor;
  var MAIN_ENTRY = isServer ? config.entry.serverMain : config.entry.clientMain;
  fs__default.existsSync(MAIN_ENTRY);
  var WEBPACK_HOOK = config.hook.webpack ? config.hook.webpack : identityFnt;
  return WEBPACK_HOOK({
    mode: isDevelopment ? "development" : "production",
    name: name,
    target: webpackTarget,
    devtool: devtool,
    context: ROOT$1,
    externals: isServer ? getServerExternals(isDevelopment, [VENDOR_ENTRY, MAIN_ENTRY]) : undefined,
    node: isClient ? {
      fs: "empty",
      __filename: "mock",
      __dirname: "mock"
    } : {},
    entry: {
      main: [isClient && isDevelopment ? "webpack-hot-middleware/client?path=/__webpack_hmr&timeout=10000&reload=true&noInfo=true&overlay=false" : null, MAIN_ENTRY].filter(Boolean)
    },
    output: {
      libraryTarget: isServer ? "commonjs2" : "var",
      filename: isDevelopment || isServer ? "[name].js" : "[name]-[chunkhash].js",
      chunkFilename: isDevelopment || isServer ? "[name].js" : "[name]-[chunkhash].js",
      path: isServer ? SERVER_OUTPUT : CLIENT_OUTPUT,
      publicPath: config.output.public,
      pathinfo: isDevelopment,
      crossOriginLoading: "anonymous"
    },
    module: {
      rules: [{
        test: babelFiles,
        loader: "source-map-loader",
        enforce: "pre",
        options: {
          quiet: true
        },
        exclude: [/intl-/, /apollo-/, /react-apollo/, /zen-observable-ts/]
      }, {
        test: assetFiles,
        loader: "file-loader",
        options: {
          name: isProduction ? "file-[hash:base62:8].[ext]" : "[path][name].[ext]",
          emitFile: isClient
        }
      }, {
        test: /\.(yml|yaml)$/,
        loaders: ["json-loader", "yaml-loader"]
      }, {
        test: /\.(graphql|gql)$/,
        loader: "graphql-tag/loader"
      }, {
        test: babelFiles,
        exclude: /node_modules/,
        use: [cacheLoader, {
          loader: "babel-loader",
          options: {
            babelrc: true,
            envName: BABEL_ENV
          }
        }].filter(Boolean)
      }, {
        test: postcssFiles,
        use: [isClient ? ExtractCssChunks.loader : null, cacheLoader, {
          loader: isClient ? "css-loader" : "css-loader/locals",
          options: cssLoaderOptions
        }, postCSSLoaderRule].filter(Boolean)
      }, {
        test: /manifest.json|\.webmanifest$/,
        type: "javascript/auto",
        use: [{
          loader: "file-loader",
          options: {
            name: isProduction ? "file-[hash:base62:8].[ext]" : "[path][name].[ext]"
          }
        }, {
          loader: "app-manifest-loader"
        }]
      }].filter(Boolean)
    },
    plugins: [new webpack.ContextReplacementPlugin(/lean-intl\/locale-data/, LEAN_INTL_REGEXP), new webpack.ContextReplacementPlugin(/react-intl\/locale-data/, REACT_INTL_REGEXP), new webpack.DefinePlugin({
      "process.env.NODE_ENV": JSON.stringify(env),
      "process.env.BUILD_TARGET": JSON.stringify(webpackTarget)
    }), new SriPlugin({
      hashFuncNames: ["sha256", "sha512"],
      enabled: isProduction && isClient
    }), new CaseSensitivePathsPlugin(), process.stdout.isTTY ? new VerboseProgress({
      prefix: PREFIX
    }) : null, isClient && isProduction ? new BundleAnalyzerPlugin.BundleAnalyzerPlugin({
      analyzerMode: "static",
      defaultSizes: "gzip",
      logLevel: "silent",
      openAnalyzer: false,
      reportFilename: "report.html"
    }) : null, isServer && isProduction ? new BundleAnalyzerPlugin.BundleAnalyzerPlugin({
      analyzerMode: "static",
      defaultSizes: "parsed",
      logLevel: "silent",
      openAnalyzer: false,
      reportFilename: "report.html"
    }) : null, isProduction && isClient ? new StatsPlugin("stats.json") : null, isClient ? new ExtractCssChunks({
      filename: isDevelopment ? "[name].css" : "[name]-[contenthash:base62:8].css",
      hot: isDevelopment
    }) : null, isClient && isDevelopment ? new webpack.HotModuleReplacementPlugin() : null].filter(Boolean)
  }, {
    isServer: isServer,
    isClient: isClient,
    isProduction: isProduction,
    isDevelopment: isDevelopment
  });
}

var removePromise = bluebird.promisify(fsExtra.remove);

function getWebpackHandler(target, resolve, reject) {
  return function (fatalError, stats) {
    if (fatalError) {
      edgeCommon.notify("Fatal error during compiling " + target + ": " + fatalError, "error");
      return reject();
    }

    var rawMessages = stats.toJson({});
    var messages = formatWebpackMessages(rawMessages);
    var isSuccessful = !messages.errors.length && !messages.warnings.length;

    if (isSuccessful) {
      edgeCommon.notify("Compiled " + target + " successfully!", "info");
    }

    if (messages.errors.length) {
      edgeCommon.notify("Failed to compile " + target + "!", "error");
      console.log(messages.errors.join("\n\n"));
      return reject();
    }

    return resolve();
  };
}

function buildClient(config) {
  if (config === void 0) {
    config = {};
  }

  var webpackConfig = builder("client", "production", config);
  return new Promise(function (resolve, reject) {
    webpack(webpackConfig, getWebpackHandler("client", resolve, reject));
  });
}
function buildServer(config) {
  if (config === void 0) {
    config = {};
  }

  var webpackConfig = builder("server", "production", config);
  return new Promise(function (resolve, reject) {
    webpack(webpackConfig, getWebpackHandler("server", resolve, reject));
  });
}
function cleanServer(config) {
  if (config === void 0) {
    config = {};
  }

  return removePromise(config.output.server);
}
function cleanClient(config) {
  if (config === void 0) {
    config = {};
  }

  return removePromise(config.output.client);
}

function createMiddleware(config) {
  if (config === void 0) {
    config = {};
  }

  var clientConfig = builder("client", "development", config);
  var serverConfig = builder("server", "development", config);
  var multiCompiler = webpack([clientConfig, serverConfig]);
  var clientCompiler = multiCompiler.compilers[0];
  var devMiddleware = webpackDevMiddleware(multiCompiler, {
    publicPath: config.output.public,
    logLevel: "silent"
  });
  var hotMiddleware = webpackHotMiddleware(clientCompiler);
  var hotServerMiddleware = webpackHotServerMiddleware(multiCompiler, {
    serverRendererOptions: {
      outputPath: config.output.client
    }
  });
  return {
    middleware: [devMiddleware, hotMiddleware, hotServerMiddleware],
    multiCompiler: multiCompiler
  };
}
function connectWithWebpack(server, multiCompiler) {
  var serverIsStarted = false;
  multiCompiler.plugin("invalid", function () {
    edgeCommon.notify("Compiling...", "info");
  });
  multiCompiler.plugin("done", function (stats) {
    var rawMessages = stats.toJson({});
    var messages = formatWebpackMessages(rawMessages);
    var isSuccessful = !messages.errors.length && !messages.warnings.length;

    if (isSuccessful) {
      edgeCommon.notify("Compiled successfully!", "info");
    }

    if (messages.errors.length) {
      edgeCommon.notify("Failed to compile!", "error");
      console.log(messages.errors.join("\n\n"));
      return;
    }

    if (messages.warnings.length) {
      edgeCommon.notify("Compiled with warnings!", "warn");
      console.log(messages.warnings.join("\n\n"));
    }

    if (!stats.hasErrors() && !serverIsStarted) {
      serverIsStarted = true;
      server.listen(process.env.SERVER_PORT, function () {
        edgeCommon.notify("Server started at port " + process.env.SERVER_PORT, "info");
        clipboardy.write("http://localhost:" + process.env.SERVER_PORT).catch(function () {});
      });
    }
  });
}

exports.cleanClient = cleanClient;
exports.cleanServer = cleanServer;
exports.buildClient = buildClient;
exports.buildServer = buildServer;
exports.connectWithWebpack = connectWithWebpack;
exports.createMiddleware = createMiddleware;
//# sourceMappingURL=index.cjs.js.map
