# Edge Builder<br/>[![Sponsored by][sponsor-img]][sponsor] [![Version][npm-version-img]][npm] [![Downloads][npm-downloads-img]][npm] [![Build Status Unix][travis-img]][travis] [![Build Status Windows][appveyor-img]][appveyor] [![Dependencies][deps-img]][deps]

[sponsor-img]: https://img.shields.io/badge/Sponsored%20by-Sebastian%20Software-692446.svg
[sponsor]: https://www.sebastian-software.de
[deps]: https://david-dm.org/sebastian-software/edge-builder
[deps-img]: https://david-dm.org/sebastian-software/edge-builder.svg
[npm]: https://www.npmjs.com/package/edge-builder
[npm-downloads-img]: https://img.shields.io/npm/dm/edge-builder.svg
[npm-version-img]: https://img.shields.io/npm/v/edge-builder.svg
[travis-img]: https://img.shields.io/travis/sebastian-software/edge-builder/master.svg?branch=master&label=unix%20build
[appveyor-img]: https://img.shields.io/appveyor/ci/swernerx/edge-builder/master.svg?label=windows%20build
[travis]: https://travis-ci.org/sebastian-software/edge-builder
[appveyor]: https://ci.appveyor.com/project/swernerx/edge-builder/branch/master

Edge Builder is a build tool for modern web applications. Part of the Edge Platform.

> The Edge Platform helps you focus on business logic rather than dealing with massive tooling, common patterns, complex configurations.

## Features

- Semi-Automatic Code-Splitting for both CSS and JS.
- Hot Loading for Client and Server using Webpack Multi Compiler Architecture.
- PostCSS powered CSS pipeline with Sass-inspired features.
- CSS Modules for Component Style Isolation.
- Build Caching using Webpacks Cache-Loader.
- Efficient Long-Term-Caching using Hashed File Names.


## Technology

- [webpack-flush-chunks](https://github.com/faceyspacey/webpack-flush-chunks)
- [react-universal-component](https://github.com/faceyspacey/react-universal-component)
- [extract-css-chunks-webpack-plugin](https://github.com/faceyspacey/extract-css-chunks-webpack-plugin)



## License

[Apache License Version 2.0, January 2004](license)


## Copyright

<img src="https://cdn.rawgit.com/sebastian-software/sebastian-software-brand/1c32115c/sebastiansoftware-en.svg" alt="Logo of Sebastian Software GmbH, Mainz, Germany" width="460" height="160"/>

Copyright 2017-2018<br/>[Sebastian Software GmbH](http://www.sebastian-software.de)
